const { EmbedBuilder } = require('discord.js');
const urban = require('urban');

module.exports = {
  name: "urban",
  description: "Searches Urban Dictionary",
  options: [{
      name: "query",
      description: "The thing you want to search for",
      required: true,
      type: 3 // 6 is type USER
  }],

  async run(client, interaction) {
      let searchWord = interaction.options._hoistedOptions[0].value;
      let search = urban(searchWord);

      let data = await search.first();

      if (data) {
          const embed = createUrbanEmbed(data, searchWord, interaction.user);
          interaction.editReply({ embeds: [embed] });
      } else {
          interaction.editReply("Sorry, no results were found!");
      }
  },
};

function createUrbanEmbed(data, searchWord, user) {
  return new EmbedBuilder()
      .setColor("#FF0000")
      .setTitle(`Results for: ${searchWord}`)
      .setDescription(`Definition: ${data.definition}`)
      .addFields({ name: 'Example', value: data.example })
      .setTimestamp()
      .setFooter({
          text: `Requested by ${user.tag}`,
          iconURL: user.displayAvatarURL()
      });
}
