const { EmbedBuilder } = require('discord.js');

module.exports = {
  name: "8ball",
  description: "Ask a question, get a response.",
  options: [{
    name: "question",
    description: "The question you would like to ask.",
    required: true,
    type: 3 // 6 is type USER
  }],
  run: async (client, interaction) => {
    let question = interaction.options._hoistedOptions[0].value;

    const responses = [
      "It is certain",
      "It is decidedly so",
      "Reply hazy try again",
      "Cannot predict now",
      "Do not count on it",
      "My sources say no",
      "Outlook not so good",
      "Signs point to yes"
    ];

    const response = responses[Math.floor(Math.random() * responses.length)];

    const embed = create8BallEmbed(question, response, interaction.user);
    interaction.editReply({ embeds: [embed] });
  },
};

function create8BallEmbed(question, response, user) {
  return new EmbedBuilder()
    .setColor("#FF0000")
    .setTitle(question)
    .setDescription(response)
    .setTimestamp()
    .setFooter({
      text: `Requested by ${user.tag}`,
      iconURL: user.displayAvatarURL()
    });
}
