const { EmbedBuilder } = require('discord.js');
const unirest = require('unirest');

module.exports = {
  name: "bored",
  description: "Find an activity to do when you are bored.",

  async run(client, interaction) {
    let response = await unirest
      .get('https://www.boredapi.com/api/activity')
      .headers({
        'Accept': 'application/json', 'Content-Type': 'application/json',
      });

    let data = response.body;
    const embed = createBoredEmbed(data, interaction.user);
    interaction.followUp({ embeds: [embed] });
  },
};

function createBoredEmbed(data, user) {
  return new EmbedBuilder()
    .setColor("#FF0000")
    .setTitle("Here is something to do!")
    .setDescription(data.activity)
    .setTimestamp()
    .setFooter({
      text: `Requested by ${user.tag}`,
      iconURL: user.displayAvatarURL()
    });
}
