const { MessageEmbed, Attachment, TextChannel } = require('discord.js');
const { AwesomeQR } = require("awesome-qr");
const fs = require("fs").promises;

let fileName;

module.exports = {
  name: "qr",
  description: "Generates a QR image",
  options: [{
    "name": "text-data",
    "description": "The data you would like inside of the QR",
    "required": true,
    "type": 3 // 6 is type USER
  }],

  run: async (client, interaction) => {
    if (!fileName) {
      fileName = Math.floor(Math.random() * 99999).toString();
    }

    const text = interaction.options._hoistedOptions[0].value;
    const background = Buffer.from(fs.readFileSync("Terminal-icon.png"));
    const buffer = await new AwesomeQR({
      text: text,
      size: 500,
      backgroundImage: background,
    }).draw();

    await fs.writeFile(`./images/${fileName}.png`, buffer);
    const file = new Attachment(`./images/${fileName}.png`);

    const embed = new MessageEmbed()
      .setColor("#FF0000")
      .setTitle("Your Generated QR Code")
      .setTimestamp()
      .setImage(`attachment://images/${fileName}.png`)
      .setFooter({ text: `Requested by ${interaction.user.tag}`, iconURL: `${interaction.user.displayAvatarURL()}` });
    try {
      const message = await interaction.channel.send({ embeds: [embed], files: [file] });
      setTimeout(async () => {
       // await message.delete();
       console.log(message)
        await fs.unlink(`./images/${fileName}.png`);
      }, 10000);
    } catch (error) {
      console.error(error);
    }
  },
};
